from gvsig import *

from java.io import File
from java.util import Date

from org.jopendocument.model import OpenDocument
from org.jopendocument.dom.spreadsheet import SpreadSheet
from org.jopendocument.dom import OOUtils

def main(*args):
    #Ejemplo de Edicion de ficheros ODS con jOpenDocument
    
    #basado en http://www.jopendocument.org/start_spreadsheet_2.html
    #ficheros plantilla http://www.jopendocument.org/downloads.html

    pathTemplate = r"C:/gvsig_informes/plantilla_invoice.ods"
    pathOutput = r"C:/gvsig_informes/resultado/fillingTest1.ods"

    #Acceso al spreadsheet y numero de hoja
    file = File(pathTemplate)
    sheet = SpreadSheet.createFromFile(file).getSheet(0)

    #Establecer fecha actual a la castilla I10
    sheet.getCellAt("I10").setValue(Date())

    #Titulo
    sheet.getCellAt("B21").setValue("Pedido n. 01")
    
    #Modifica el valor a la celda 1,1. Seria B2
    sheet.setValueAt("Presupuesto parcela n. 1", 1, 1)

    #Varias modificaciones a las celdas
    sheet.getCellAt("F24").setValue(123)
    
    sheet.getCellAt("B27").setValue("Personal")
    sheet.getCellAt("H27").setValue(2)
    sheet.getSpreadSheet().getTableModel("Products").setValueAt(10, 5, 4) #F27

    #Guardamos fichero
    outputFile = File(pathOutput)
    OOUtils.open(sheet.getSpreadSheet().saveAs(outputFile))
